/**
 * 响应拦截
 * @param {Object} http 
 */
module.exports = (vm) => {

    uni.$u.http.interceptors.response.use((response) => { 
		// console.log('response',response)
		/* 对响应成功做点什么 可使用async await 做异步操作*/
		uni.hideLoading()
        const data = response.data
		if(response.statusCode==401){
			const redirect = window.location.href;
			window.location.href = `${window._CONFIG.VUE_APP_BASE_URLS}/account/#/login?redirect=${redirect}`;
			return Promise.reject(data)
		}
        // 自定义参数
        const custom = response.config?.custom
        if (response.statusCode !== 200) { 
			// 服务端返回的状态码不等于200，则reject()
            // 如果没有显式定义custom的toast参数为false的话，默认对报错进行toast弹出提示
            if (custom.toast !== false) {
                uni.$u.toast(data.errMsg)
            }
            // 如果需要catch返回，则进行reject
            if (custom?.catch) {
                return Promise.reject(data)
            } else {
                // 否则返回一个pending中的promise
                return new Promise(() => { })
            }
        }
		if(data.errMsg){
			uni.$u.toast(data.errMsg)
		}
        return data
    }, (response) => { 
		/*  对响应错误做点什么 （statusCode !== 200）*/
		if(response.statusCode==401){
			const redirect = window.location.href;
			window.location.href = `${window._CONFIG.VUE_APP_BASE_URLS}/account/#/login?redirect=${redirect}`;
			return Promise.reject(response)
		}
		if(response.data.message){
			uni.$u.toast(response.data.message)
		}else if(response.data.errMsg){
			uni.$u.toast(response.data.errMsg)
		}else{
			uni.$u.toast('网络错误')
		}
        return Promise.reject(response)
    })
}